﻿Imports System.Text
Imports System.Threading.Tasks

Namespace JeuAvecDesKilometres
    Public Class Embuche
        Inherits Carte
        Public Sub New(ByVal CheminImage As String, ByVal LeType As TypeEmbuche)
            MyBase.New(CheminImage, 0)
            Type = LeType
        End Sub

        Private privateType As TypeEmbuche
        Public Property Type As TypeEmbuche
            Get
                Return privateType
            End Get
            Private Set(ByVal value As TypeEmbuche)
                privateType = value
            End Set
        End Property

        ''' <summary>
        ''' Une embûche est lancée à un autre joueur
        ''' </summary>
        ''' <param name="Cible"></param>
        Public Sub Jouer(ByVal Cible As Joueur)
            'ToDo implémenter le jeu de l'embuche
        End Sub

        ''' <summary>
        ''' Réécriture de ToString pour afficher le nom de l'embûche
        ''' </summary>
        ''' <returns></returns>
        Public Overrides Function ToString() As String
            Return Type.ToString()
        End Function

        ''' <summary>
        ''' Méthode de classe qui génère la liste d'Embuches
        ''' </summary>
        ''' <returns></returns>
        Public Shared Function Generer() As List(Of Carte)
            Dim resultat As New List(Of Carte)()

            For i As Integer = 0 To 4
                resultat.Add(New Embuche("Image du feu rouge", TypeEmbuche.FeuRouge))
            Next i

            For i As Integer = 0 To 3
                resultat.Add(New Embuche("Image de la limitation de vitesse", TypeEmbuche.LimitationVitesse))
            Next i

            For i As Integer = 0 To 2
                resultat.Add(New Embuche("Image de la panne d'essence", TypeEmbuche.PanneEssence))
            Next i

            For i As Integer = 0 To 2
                resultat.Add(New Embuche("Image de la crevaison", TypeEmbuche.Crevaison))
            Next i

            For i As Integer = 0 To 2
                resultat.Add(New Embuche("Image de l'accident", TypeEmbuche.Accident))
            Next i

            Return resultat
        End Function

        ''' <summary>
        ''' Implémentation de ordre dans Embuche
        ''' </summary>
        Public Overrides ReadOnly Property Ordre As Integer
            Get
                Return CInt(Type) + 3
            End Get
        End Property

    End Class
End Namespace
